#!/bin/sh

# Mumble (Murmur) install on Fedora 33

# OPTIONAL BUT RECOMMENDED - Set a password that will be required to join the server. Leaving this blank will make the server public.
SERVER_PASSWORD='SET_A_PASSWORD_HERE_IF_YOU_WANT'

# Disable firewalld (Cloud provider firewall will suffice)
# AWS AMI for Fedora 33 already has this off.

systemctl stop firewalld

# Install Murmur 

dnf install -y murmur

# OPTIONAL - Manually set DH from 2048 to 4096, manually generate SSL cert with 4096 RSA.
# If you just ignore this, mumble will do it's default DH 2048 and generate an SSL cert with 2048 RSA.

dnf install -y openssl
cd /etc/murmur
openssl req -x509 -nodes -days 365 -subj '/CN=mumbleserver/O=mumbleserver/C=SG' -newkey rsa:4096 -keyout ssl.key -out ssl.crt
chmod 644 ssl.crt
chmod 644 ssl.key
sed -i -e 's/;sslCert=/sslCert=ssl.crt/g' murmur.ini
sed -i -e 's/;sslKey=/sslKey=ssl.key/g' murmur.ini

# OPTIONAL BUT RECOMMENDED - Set a password that will be required to join the server

sed -i -e "s/serverpassword=/serverpassword=$SERVER_PASSWORD/g" murmur.ini

# Start Murmur server

systemctl start murmur

#### DDNS to update a Cloudflare DNS zone A record with server IP

DOMAIN_OR_SUBDOMAIN='YOUR_DOMAIN_GOES_HERE'
ZONE_ID='CLOUDFLARE_ZONE_ID_GOES_HERE'
RECORD_ID='CLOUDFLARE_RECORD_ID_GOES_HERE'
EMAIL='CLOUDFLARE_EMAIL_GOES_HERE'
API_TOKEN='CLOUDFLARE_API_TOKEN_GOES_HERE'

ipadr=`curl checkip.amazonaws.com`
curl -X PUT "https://api.cloudflare.com/client/v4/zones/$ZONE_ID/dns_records/$RECORD_ID" \
     -H "X-Auth-Email: $EMAIL" \
     -H "Authorization: Bearer $API_TOKEN" \
     -H "Content-Type: application/json" \
     --data '{"type":"A","name":"'$DOMAIN_OR_SUBDOMAIN'","content":"'${ipadr}'","ttl":1,"proxied":false}'
echo ""
